unit uGrid;

interface

uses
  System.SysUtils, System.Classes, JS, WEBLib.JSON, Web, WEBLib.Graphics, WEBLib.Controls,
  WEBLib.Forms, WEBLib.Dialogs, WEBLib.ExtCtrls, Vcl.Controls, WEBLib.TreeNodes,
  Vcl.ComCtrls, WEBLib.ComCtrls, WEBLib.ContinuousScroll, Vcl.StdCtrls,
  WEBLib.StdCtrls, jsdelphisystem, Data.DB, WEBLib.CDS, WEBLib.DBCtrls,
  WEBLib.DB, Vcl.Grids, uDetail;

type
  TfrmGrid = class(TfrmDetail)
    pNav: TWebPanel;
    navMain: TWebDBNavigator;
    mRowsJSON: TWebMemo;
    grdMain: TWebDBGrid;
  private
    { Private declarations }
    cdMain: TWebClientDataset;
    dsMain: TWebDataSource;
    procedure DatasetAfterInsert(DataSet: TDataSet);
  public
    { Public declarations }
    procedure SetupForm(); override;
  end;

implementation

{$R *.dfm}

procedure TfrmGrid.SetupForm();
var
  LFieldDefs: TFieldDefs;
  LFieldDef: TFieldDef;
  S: String;
  I: Integer;
  LColumn: TWebGridColumn;
begin
  inherited SetupForm();

  cdMain := TWebClientDataSet.Create(nil);

  LFieldDefs := TFieldDefs.Create(nil);

  LFieldDef := LFieldDefs.AddFieldDef();
  LFieldDef.DataType := ftInteger;
  LFieldDef.DisplayName := 'Id';
  LFieldDef.Name := 'id';

  LFieldDef := LFieldDefs.AddFieldDef();
  LFieldDef.DataType := ftString;
  LFieldDef.DisplayName := 'Code';
  LFieldDef.Name := 'code';

  LFieldDef := LFieldDefs.AddFieldDef();
  LFieldDef.DataType := ftMemo;
  LFieldDef.DisplayName := 'Description';
  LFieldDef.Name := 'descr';

  LFieldDef := LFieldDefs.AddFieldDef();
  LFieldDef.DataType := ftFloat;
  LFieldDef.DisplayName := 'Amount';
  LFieldDef.Name := 'amount';

  LFieldDef := LFieldDefs.AddFieldDef();
  LFieldDef.DataType := ftDateTime;
  LFieldDef.DisplayName := 'Timestamp';
  LFieldDef.Name := 'ts';

  cdMain.FieldDefs := LFieldDefs;

  cdMain.Rows := TJSArray(TJSJSON.parseObject(mRowsJSON.Lines.Text));
  cdMain.Open;

  grdMain.Columns.Clear;

  LColumn := grdMain.Columns.Add;
  LColumn.ElementClassName := '';
  LColumn.DataField := 'id';
  LColumn.DataType := TColumnDataType.cdText;
  LColumn.Width := 200;
  LColumn.Title := 'Id';
  LColumn.TitleElementClassName := '';

  LColumn := grdMain.Columns.Add;
  LColumn.ElementClassName := '';
  LColumn.DataField := 'code';
  LColumn.DataType := TColumnDataType.cdText;
  LColumn.Width := 200;
  LColumn.Title := 'Code';
  LColumn.TitleElementClassName := '';

  LColumn := grdMain.Columns.Add;
  LColumn.ElementClassName := '';
  LColumn.DataField := 'descr';
  LColumn.DataType := TColumnDataType.cdText;
  LColumn.Width := 200;
  LColumn.Title := 'Description';
  LColumn.TitleElementClassName := '';

  LColumn := grdMain.Columns.Add;
  LColumn.ElementClassName := '';
  LColumn.DataField := 'amount';
  LColumn.DataType := TColumnDataType.cdText;
  LColumn.Width := 200;
  LColumn.Title := 'Amount';
  LColumn.TitleElementClassName := '';

  LColumn := grdMain.Columns.Add;
  LColumn.ElementClassName := '';
  LColumn.DataField := 'ts';
  LColumn.DataType := TColumnDataType.cdText;
  LColumn.Width := 200;
  LColumn.Title := 'Timestamp';
  LColumn.TitleElementClassName := '';

  cdMain.AfterInsert := DatasetAfterInsert;

  DataSource.DataSet := cdMain;
  grdMain.DataSource := DataSource;
  navMain.DataSource := DataSource;
end;

procedure TfrmGrid.DatasetAfterInsert(DataSet: TDataSet);
begin

end;

end.
